﻿--[[ Version Information ]]--
RECIPEBOOK_VERSION_NUMBER = "3.3.2";
RECIPEBOOK_REVISION_CODE = "beta 2";
RECIPEBOOK_VERSION = RECIPEBOOK_VERSION_NUMBER.."-"..RECIPEBOOK_REVISION_CODE;
RECIPEBOOK_VERSION_TEXT = "RecipeBook v. "..RECIPEBOOK_VERSION;
RECIPEBOOK_COMPATIBLE = {3, 3, 2, ""};
RECIPEBOOK_DATAVERSION = 14;
RECIPEBOOK_UPDATEFREQUENCY = 1;

RECIPEBOOK_TOOLTIPWIDTH = 38;

--[[ Color coding data ]]--
RB_HEXCOLOR = {
	["red"] 	= "|cffff0000",
	["orange"] 	= "|cffff9900",
	["yellow"] 	= "|cffffff00",
	["green"] 	= "|cff00ff00",
	["cyan"] 	= "|cff33ccff",
	["grey"] 	= "|ccccccc00",
	["end"] 	= "|r",
};

RECIPEBOOK_DIFFICULTY = {"unknown", "default", "trivial", "easy", "medium", "optimal"};
RB_DIFFCOLOR = {
	{ r = 1.00, g = 0.00, b = 0.00 }, -- skill -1 or shared
	{ r = 1.00, g = 1.00, b = 1.00 }, -- skill 0 or shared
	{ r = 0.50, g = 0.50, b = 0.50 }, -- skill 1 or trivial
	{ r = 0.25, g = 0.75, b = 0.25 }, -- skill 2 or easy
	{ r = 1.00, g = 1.00, b = 0.00 }, -- skill 3 or medium
	{ r = 1.00, g = 0.50, b = 0.25 }, -- skill 4 or optimal
};

-----------------------------------------------------[[ SHARING PARSER: DO NOT TRANSLATE ]]-----------------------------------------
--[[ Send Data ]]--
RECIPEBOOK_SHARETRIGGER = "R\195\159";
--== Templates ==--
RECIPEBOOK_SHARET_TRIGGER = ":<|>"
RECIPEBOOK_SHARET_WHO = "<P:%s>";
RECIPEBOOK_SHARET_FAC = "<F:%d>";
RECIPEBOOK_SHARET_SKILL = "<T:%s>";
RECIPEBOOK_SHARET_VER = "<V:"..RECIPEBOOK_VERSION..">";
RECIPEBOOK_SHARET_DATA = "<R:%d/%d-%d:%d>";
RECIPEBOOK_SHARET_ITEM = "<I:%d>";
RECIPEBOOK_SHARET_DIFF = "<D:%d>";
RECIPEBOOK_SHARET_MAT = "<M:%d#%d>";
RECIPEBOOK_SHARET_ERROR = "<E:%s>";
RECIPEBOOK_SHARET_FULLINK = "<L:%d>";
RECIPEBOOK_SHARET_NUMITEMS = "<N:%d>";
RECIPEBOOK_SHARET_ITEMNAME = "<X:%s>";
RECIPEBOOK_SHARET_ALTNAME = "<Y:%s>";

--== Strings ==--
RECIPEBOOK_SHARETRIGGER_INITIATE = "Initiate Session";
RECIPEBOOK_SHARE_INITIATE = RECIPEBOOK_SHARETRIGGER_INITIATE .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_VER;
--RECIPEBOOK_SHARETRIGGER_PROMPTING is not used.
RECIPEBOOK_SHARE_PROMPTING = "Prompting for share acceptance.";
RECIPEBOOK_SHARETRIGGER_ACCEPT = "Go ahead";
RECIPEBOOK_SHARE_ACCEPT = RECIPEBOOK_SHARETRIGGER_ACCEPT .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_VER;
RECIPEBOOK_SHARETRIGGER_DECLINE = "Decline"
RECIPEBOOK_SHARE_DECLINE = RECIPEBOOK_SHARETRIGGER_DECLINE .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_ERROR;
RECIPEBOOK_SHARETRIGGER_OPENSKILL = "Send Tradeskill"
RECIPEBOOK_SHARE_OPENSKILL = RECIPEBOOK_SHARETRIGGER_OPENSKILL .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_FAC .. RECIPEBOOK_SHARET_DATA;
RECIPEBOOK_SHARETRIGGER_ACCEPTSKILL = "Yes Tradeskill"
RECIPEBOOK_SHARE_ACCEPTSKILL = RECIPEBOOK_SHARETRIGGER_ACCEPTSKILL .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_SKILL;
RECIPEBOOK_SHARETRIGGER_DECLINESKILL = "No Tradeskill"
RECIPEBOOK_SHARE_DECLINESKILL = RECIPEBOOK_SHARETRIGGER_DECLINESKILL .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_SKILL;
RECIPEBOOK_SHARETRIGGER_REQUEST = "Request Update";
RECIPEBOOK_SHARE_REQUEST = RECIPEBOOK_SHARETRIGGER_REQUEST .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_VER;
RECIPEBOOK_SHARETRIGGER_NOUPDATE = "No Update";
RECIPEBOOK_SHARE_NOUPDATE = RECIPEBOOK_SHARETRIGGER_NOUPDATE .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_ERROR;
RECIPEBOOK_SHARETRIGGER_AUTOUPDATE = "Initiate AutoUpdate";
RECIPEBOOK_SHARE_AUTOUPDATE = RECIPEBOOK_SHARETRIGGER_AUTOUPDATE .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_VER;
RECIPEBOOK_SHARETRIGGER_AUDECLINE = "AU Decline";
RECIPEBOOK_SHARE_AUDECLINE = RECIPEBOOK_SHARETRIGGER_AUDECLINE .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_ERROR;
RECIPEBOOK_SHARETRIGGER_CANCEL = "Cancel Session";
RECIPEBOOK_SHARE_CANCEL = RECIPEBOOK_SHARETRIGGER_CANCEL .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO;
RECIPEBOOK_SHARE_CANCELERR = RECIPEBOOK_SHARE_CANCEL .. RECIPEBOOK_SHARET_ERROR;
RECIPEBOOK_SHARETRIGGER_TERMINATE = "Completed Send";
RECIPEBOOK_SHARE_TERMINATE = RECIPEBOOK_SHARETRIGGER_TERMINATE .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_NUMITEMS;
RECIPEBOOK_SHARETRIGGER_TENFOUR = "Acknowledged";
RECIPEBOOK_SHARE_TENFOUR = RECIPEBOOK_SHARETRIGGER_TENFOUR .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_SKILL;
RECIPEBOOK_SHARETRIGGER_ITEM = "Item";
RECIPEBOOK_SHARE_ITEM = RECIPEBOOK_SHARETRIGGER_ITEM .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_ITEM .. RECIPEBOOK_SHARET_ITEMNAME .. RECIPEBOOK_SHARET_DIFF .. RECIPEBOOK_SHARET_FULLINK .. RECIPEBOOK_SHARET_ALTNAME;
RECIPEBOOK_SHARETRIGGER_LASTITEM = "/Items";
RECIPEBOOK_SHARE_LASTITEM = RECIPEBOOK_SHARETRIGGER_LASTITEM .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_ITEM;
RECIPEBOOK_SHARETRIGGER_OKITEMS = "/OK"
RECIPEBOOK_SHARE_OKITEMS = RECIPEBOOK_SHARETRIGGER_OKITEMS .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_WHO .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_ITEM;
RECIPEBOOK_SHARETRIGGER_SENDMATS = "?Mats";
RECIPEBOOK_SHARE_SENDMATS = RECIPEBOOK_SHARETRIGGER_SENDMATS .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_ITEM .. RECIPEBOOK_SHARET_FULLINK;
RECIPEBOOK_SHARETRIGGER_SENDNOMATS = "OK"
RECIPEBOOK_SHARE_SENDNOMATS = RECIPEBOOK_SHARETRIGGER_SENDNOMATS .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_ITEM;
RECIPEBOOK_SHARETRIGGER_MATS = "Mats"
RECIPEBOOK_SHARE_MATS = RECIPEBOOK_SHARETRIGGER_MATS .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_ITEM .. RECIPEBOOK_SHARET_FULLINK;
RECIPEBOOK_SHARETRIGGER_ACKMATS = "OK Mats"
RECIPEBOOK_SHARE_ACKMATS = RECIPEBOOK_SHARETRIGGER_ACKMATS .. RECIPEBOOK_SHARET_TRIGGER .. RECIPEBOOK_SHARET_SKILL .. RECIPEBOOK_SHARET_ITEM .. RECIPEBOOK_SHARET_FULLINK;

--== Errors and cancellations ==--
RECIPEBOOK_SHARETRIGGER_CANCEL = "Cancel share: ";
RECIPEBOOK_SHARE_CANCEL = RECIPEBOOK_SHARETRIGGER_CANCEL..RECIPEBOOK_SHARET_WHO;
RECIPEBOOK_SHARE_CANCELERR = RECIPEBOOK_SHARETRIGGER_CANCEL..RECIPEBOOK_SHARET_WHO..RECIPEBOOK_SHARET_ERROR;
RECIPEBOOK_SHARETRIGGER_NOUPDATE = "Declining update request: ";
RECIPEBOOK_SHARE_NOUPDATE = RECIPEBOOK_SHARETRIGGER_NOUPDATE ..RECIPEBOOK_SHARET_ERROR;
RECIPEBOOK_SHARETRIGGER_NOAUTOUPDATE = "Declining AutoUpdate request: ";
RECIPEBOOK_SHARE_NOAUTOUPDATE = RECIPEBOOK_SHARETRIGGER_NOUPDATE ..RECIPEBOOK_SHARET_ERROR;

--== Special Books ==--
RECIPEBOOK_BOOKS = {
	[16072] = 225, -- Expert Cooking
	[27736] = 375, -- Master Cooking
	[16083] = 225, -- Expert Fishing
	[27532] = 375, -- Master Fishing
	[16084] = 225, -- Expert First Aid
	[22012] = 375, -- Master First Aid
}
